Moose::Util::MetaRole(3)

NAME
Moose::Util::MetaRole - Apply roles to any metaclass, as well as the object base class

VERSION
version 2.1801

SYNOPSIS
  package MyApp::Moose;

  use Moose ();
  use Moose::Exporter;
  use Moose::Util::MetaRole;

  use MyApp::Role::Meta::Class;
  use MyApp::Role::Meta::Method::Constructor;
  use MyApp::Role::Object;

  Moose::Exporter->setup_import_methods( also => 'Moose' );

  sub init_meta {
      shift;
      my %args = @_;

      Moose->init_meta(%args);

      Moose::Util::MetaRole::apply_metaroles(
          for             => $args{for_class},
          class_metaroles => {
              class       => ['MyApp::Role::Meta::Class'],
              constructor => ['MyApp::Role::Meta::Method::Constructor'],
          },
      );

      Moose::Util::MetaRole::apply_base_class_roles(
          for   => $args{for_class},
          roles => ['MyApp::Role::Object'],
      );

      return $args{for_class}->meta();
  }

DESCRIPTION
This utility module is designed to help authors of Moose extensions write extensions that are able to cooperate with other Moose extensions. To do this, you must write your extensions as roles, which can then be dynamically applied to the caller's metaclasses.

This module makes sure to preserve any existing superclasses and roles already set for the meta objects, which means that any number of extensions can apply roles in any order.

USAGE
The easiest way to use this module is through Moose::Exporter, which can generate the appropriate "init_meta" method for you, and make sure it is called when imported.

FUNCTIONS
This module provides two functions.

  apply_metaroles( ... )
This function will apply roles to one or more metaclasses for the specified class. It will return a new metaclass object for the class or role passed in the "for" parameter.

It accepts the following parameters:

•   for => $name

    This specifies the class or for which to alter the meta classes. This can be a package name, or an appropriate meta-object (a Moose::Meta::Class or Moose::Meta::Role).

•   class_metaroles => \%roles

    This is a hash reference specifying which metaroles will be applied to the class metaclass and its contained metaclasses and helper classes.

    Each key should in turn point to an array reference of role names.

    It accepts the following keys:

    class
    attribute
    method
    wrapped_method
    instance
    constructor
    destructor
    error
•   role_metaroles => \%roles

    This is a hash reference specifying which metaroles will be applied to the role metaclass and its contained metaclasses and helper classes.

    It accepts the following keys:

    role
    attribute
    method
    required_method
    conflicting_method
    application_to_class
    application_to_role
    application_to_instance
    application_role_summation
    applied_attribute

  apply_base_class_roles( for => $class, roles => \@roles )
This function will apply the specified roles to the object's base class.

BUGS
See "BUGS" in Moose for details on reporting bugs.

AUTHORS

•   Stevan Little <stevan.little@iinteractive.com>

•   Dave Rolsky <autarch@urth.org>

•   Jesse Luehrs <doy@tozt.net>

•   Shawn M Moore <code@sartak.org>

•   יובל קוג'מן (Yuval Kogman) <nothingmuch@woobling.org>

•   Karen Etheridge <ether@cpan.org>

•   Florian Ragwitz <rafl@debian.org>

•   Hans Dieter Pearcey <hdp@weftsoar.net>

•   Chris Prather <chris@prather.org>

•   Matt S Trout <mst@shadowcat.co.uk>

COPYRIGHT AND LICENSE
This software is copyright (c) 2006 by Infinity Interactive, Inc.

This is free software; you can redistribute it and/or modify it under the same terms as the Perl 5 programming language system itself.